// DlgCommon.cpp : t@C
//

#include "stdafx.h"
#include "LLog.h"
#include "DlgCommon.h"


// CDlgCommon _CAO

IMPLEMENT_DYNAMIC(CDlgCommon, CDialog)

CDlgCommon::CDlgCommon(UINT nID, CWnd* pParent)
	: CDialog(nID, pParent)
{
	m_sizeDlg = 0;
	m_bSizeChange = FALSE;
}

void CDlgCommon::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CDlgCommon, CDialog)
	ON_WM_SIZE()
//	ON_MESSAGE(WM_EXITSIZEMOVE, OnExitSizeMove)
	ON_WM_GETMINMAXINFO()
END_MESSAGE_MAP()


UINT CDlgCommon::DispDialog(CDataBase &oDataBase, CTime oDate)
{
	m_pDataBase = &oDataBase;
	m_oDate = oDate;

	return DoModal();
}

void CDlgCommon::SetCtlPosition(UINT nID, double fLeft, double fTop, double fRight, double fBottom)
{
	CWnd *pWnd = GetDlgItem(nID);

	HWND hWnd = pWnd->GetSafeHwnd();
	if (hWnd == NULL)
		return;

	// ݒ\̂ɐݒ
	SDlgCtlPosition cDlgCtlPosition;
	cDlgCtlPosition.hWnd = hWnd;
	cDlgCtlPosition.fLeft = fLeft;
	cDlgCtlPosition.fTop = fTop;
	cDlgCtlPosition.fRight = fRight;
	cDlgCtlPosition.fBottom = fBottom;

	// ݂̃EBhEʒu擾
	WINDOWPLACEMENT wp;
	pWnd->GetWindowPlacement(&wp);
	cDlgCtlPosition.rectCtl = wp.rcNormalPosition;

	// zɐݒǉ
	m_aDlgCtlPosition.Add(cDlgCtlPosition);
}

BOOL CDlgCommon::OnInitDialog()
{
	CDialog::OnInitDialog();

	CRect rect;
	GetClientRect(rect);
	m_sizeDlg = rect.Size();

	return TRUE;
}

void CDlgCommon::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	// _CAORg[K؂ȈʒuɍĔzu
	if (m_sizeDlg.cx && cx != 0) {
		// TCY̍
		int nx = cx - m_sizeDlg.cx;
		int ny = cy - m_sizeDlg.cy;

		// ύXꂽTCY_CAÕRg[̑傫ƈʒuύX
		int nDlgCtlPosition = (int)m_aDlgCtlPosition.GetSize();
		for (int i = 0; i < nDlgCtlPosition; i++) {
			// qEBhE擾
			SDlgCtlPosition &cDlgCtlPosition = m_aDlgCtlPosition[i];
			CWnd *pWnd = FromHandle(m_aDlgCtlPosition[i].hWnd);

			// qEBhËʒuA傫擾
			CRect rect(cDlgCtlPosition.rectCtl);

			// ʒuƑ傫𒲐
			rect.left += (int)(nx * cDlgCtlPosition.fLeft);
			rect.top += (int)(ny * cDlgCtlPosition.fTop);
			rect.right += (int)(nx * cDlgCtlPosition.fRight);
			rect.bottom += (int)(ny * cDlgCtlPosition.fBottom);

			// qEBhEړ
			pWnd->SetWindowPos(NULL, rect.left, rect.top, rect.Width(), rect.Height(), SWP_NOZORDER);
		}

		// TCYύXtOON
		m_bSizeChange = TRUE;

		Invalidate(FALSE);
//		UpdateWindow();
	}
}

LRESULT CDlgCommon::OnExitSizeMove(WPARAM wParam, LPARAM lParam)
{
	// TCYύXtOONȂ_CAOĕ\
	if (m_bSizeChange) {
		Invalidate();
		m_bSizeChange = FALSE;
	}

	return 0;
}

void CDlgCommon::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	// EBhE̍ŏTCYݒ
	if (m_sizeDlg.cx != 0) {
		lpMMI->ptMinTrackSize.x = m_sizeDlg.cx;
		lpMMI->ptMinTrackSize.y = m_sizeDlg.cy;
	}

	CDialog::OnGetMinMaxInfo(lpMMI);
}
